## START: Set by rpmautospec
## (rpmautospec version 0.6.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by rust2rpm 24
%bcond_without check

%global crate vhost-device-scmi

%if 0%{?rhel}
# RHEL: Use bundled deps as it doesn't ship Rust libraries
%global bundled_rust_deps 1
%else
# Fedora: Use only system Rust libraries
%global bundled_rust_deps 0
%endif

Name:           rust-vhost-device-scmi
Version:        0.2.0
Release:        %autorelease
Summary:        Vhost-user SCMI backend device

License:        Apache-2.0 OR BSD-3-Clause
URL:            https://crates.io/crates/vhost-device-scmi
Source0:        %{crates_source}

%if 0%{?bundled_rust_deps}
# The source tarball is downloaded using the following commands:
#   spectool -g rust-vhost-device-scmi.spec
Source1: https://github.com/rust-vmm/vhost-device/archive/refs/tags/%{crate}-v%{version}.tar.gz

# The vendor tarball is created using cargo-vendor-filterer to remove Windows
# related files (https://github.com/cgwalters/cargo-vendor-filterer)
#   tar xzf vhost-device-scmi-v%%{version}.tar.gz
#   cd vhost-device-vhost-device-scmi-v%%{version}/vhost-device-scmi
#   cargo vendor-filterer --platform x86_64-unknown-linux-gnu \
#       --platform powerpc64le-unknown-linux-gnu \
#       --platform aarch64-unknown-linux-gnu \
#       --platform i686-unknown-linux-gnu
#   tar Jcf rust-vhost-device-scmi-%%{version}-vendor.tar.xz vendor
Source2: rust-vhost-device-scmi-%{version}-vendor.tar.xz
%endif

# Upstream doesn't provide man pages
Patch0:         rust-vhost-device-scmi-man-page.patch
# Unused code removed to make rustc happy
Patch1:         rust-vhost-device-scmi-unused-code.patch

%if 0%{?bundled_rust_deps}
BuildRequires:  rust-toolset
# vendored crates dependencies:
%else
BuildRequires:  cargo-rpm-macros >= 24
%endif

# Unit tests fail on s390x, see bug #2244364.
ExcludeArch: s390x

%global _description %{expand:
Vhost-user SCMI backend device.}

%description %{_description}

%package     -n %{crate}
Summary:        %{summary}
License:        (Apache-2.0 OR BSD-3-Clause) AND ((MIT OR Apache-2.0) AND Unicode-DFS-2016) AND (Apache-2.0 OR MIT) AND (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND Apache-2.0 AND BSD-3-Clause AND MIT AND (Unlicense OR MIT)
# LICENSE.dependencies contains a full license breakdown

%description -n %{crate} %{_description}

%files       -n %{crate}
%license LICENSE-APACHE
%license LICENSE-BSD-3-Clause
%license LICENSE.dependencies
%if 0%{?bundled_rust_deps}
%license cargo-vendor.txt
%endif
%doc CHANGELOG.md
%doc README.md
%{_bindir}/vhost-device-scmi
%{_mandir}/man1/*

%prep
%if 0%{?bundled_rust_deps}
# Source2 is vendored dependencies
%autosetup -n %{crate}-%{version_no_tilde} -p1 -N %{?bundled_rust_deps:-a1} %{?bundled_rust_deps:-a2}
%autopatch -p1
%cargo_prep -v vendor
%else
%autosetup -n %{crate}-%{version} -p1
%cargo_prep
%endif

%if ! 0%{?bundled_rust_deps}
%generate_buildrequires
%cargo_generate_buildrequires
%endif

%build
%cargo_build
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies
%if 0%{?bundled_rust_deps}
%cargo_vendor_manifest
%endif

%install
%cargo_install
mkdir -p %{buildroot}/%{_mandir}/man1
install -m 644 vhost-device-scmi.1 %{buildroot}/%{_mandir}/man1/

%if %{with check}
%check
%cargo_test
%endif

%changelog
## START: Generated by rpmautospec
* Fri Jul 26 2024 Sandro Bonazzola <sbonazzo@redhat.com> - 0.2.0-2
- Add RHEL packaging

* Tue Jul 23 2024 Milan Zamazal <mzamazal@redhat.com> - 0.2.0-1
- Update to version 0.2.0

* Sat Jul 20 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Thu May 23 2024 Fabio Valentini <decathorpe@gmail.com> - 0.1.0-6
- Rebuild with Rust 1.78 to fix incomplete debuginfo and backtraces

* Wed Jan 31 2024 Milan Zamazal <mzamazal@redhat.com> - 0.1.0-5
- Update dependencies versions; Fixes RHBZ#2261676

* Tue Jan 30 2024 Milan Zamazal <mzamazal@redhat.com> - 0.1.0-4
- Build-depend on cargo-rpm-macros rather than rust-packaging.

* Sat Jan 27 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Oct 16 2023 Milan Zamazal <mzamazal@redhat.com> - 0.1.0-2
- Exclude s390x architecture.

* Fri Oct 13 2023 Milan Zamazal <mzamazal@redhat.com> - 0.1.0-1
- Initial import (fedora#2242449).
## END: Generated by rpmautospec
